# -*- coding:Utf-8 -*

import urllib, threading, os

import es, gamethread

class Collector(threading.Thread):
    """Download and install the ban list every specified time"""

    # Mutex
    __LOCK = threading.Lock()

    def __init__(self, name, url, time, destination):
        """
            New ban list Collector
            'name' is the name of the thread
            'url' is the URL of the ban list
            'time' is the delay between each update
            'destination' is the ban list path
            All parameters are optionnals
        """

        threading.Thread.__init__(self)

        self.__name = name
        self.__url = url
        self.__time = time
        self.__destination = destination
        self.__stopevent = threading.Event()

        es.dbgmsg(1,"Creating Collector %s..." % self.__name)


    def run(self):
        """Corpse"""

        gamethread.queue(es.dbgmsg,(0,"banlistUpdater : Collector started for %s" % self.__url))

        while not self.__stopevent.isSet():
            gamethread.queue(es.dbgmsg,(0,"banlistUpdater : Updating %s" % self.__name))

            try:
                gamethread.queue(es.dbgmsg,(1,"banlistUpdater : Try to contact %s" % self.__url))
                banlist = urllib.urlopen(self.__url).read()
                gamethread.queue(es.dbgmsg,(1,"banlistUpdater : Download completed"))
                try:
                    Collector.__LOCK.acquire()
                    
                    destPath = os.getcwd() + "/" + self.__destination
                    dest = open(destPath,"w")
                    dest.write(banlist)
                    dest.close()
                    gamethread.queue(es.dbgmsg,(1,"banlistUpdater : Update completed (%s)" % destPath))
                finally:
                    Collector.__LOCK.release()
            except Exception, e:
                gamethread.queue(es.dbgmsg,(0,"banlistUpdater : %s" % e))

            self.__stopevent.wait(self.__time)

    def stop(self):
        """Kill the Collector"""

        self.__stopevent.set()
